xref: /linux/scripts/Makefile.gcc-plugins (revision c61f13eaa1ee17728c41370100d2d45c254ce76f)
1ifdef CONFIG_GCC_PLUGINS
2  __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC))
3  PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)")
4
5  SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so
6
7  gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY)	+= cyc_complexity_plugin.so
8
9  gcc-plugin-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY)	+= latent_entropy_plugin.so
10  gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY)	+= -DLATENT_ENTROPY_PLUGIN
11  ifdef CONFIG_PAX_LATENT_ENTROPY
12    DISABLE_LATENT_ENTROPY_PLUGIN			+= -fplugin-arg-latent_entropy_plugin-disable
13  endif
14
15  ifdef CONFIG_GCC_PLUGIN_SANCOV
16    ifeq ($(CFLAGS_KCOV),)
17      # It is needed because of the gcc-plugin.sh and gcc version checks.
18      gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV)           += sancov_plugin.so
19
20      ifneq ($(PLUGINCC),)
21        CFLAGS_KCOV := $(SANCOV_PLUGIN)
22      else
23        $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler)
24      endif
25    endif
26  endif
27
28  gcc-plugin-$(CONFIG_GCC_PLUGIN_STRUCTLEAK)	+= structleak_plugin.so
29  gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_VERBOSE)	+= -fplugin-arg-structleak_plugin-verbose
30  gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK)	+= -DSTRUCTLEAK_PLUGIN
31
32  GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
33
34  export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR
35  export SANCOV_PLUGIN DISABLE_LATENT_ENTROPY_PLUGIN
36
37  ifneq ($(PLUGINCC),)
38    # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication.
39    GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS))
40  endif
41
42  KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)
43  GCC_PLUGIN := $(gcc-plugin-y)
44  GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y)
45endif
46
47# If plugins aren't supported, abort the build before hard-to-read compiler
48# errors start getting spewed by the main build.
49PHONY += gcc-plugins-check
50gcc-plugins-check: FORCE
51ifdef CONFIG_GCC_PLUGINS
52  ifeq ($(PLUGINCC),)
53    ifneq ($(GCC_PLUGINS_CFLAGS),)
54      ifeq ($(call cc-ifversion, -ge, 0405, y), y)
55	$(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true
56	@echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1
57      else
58	@echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1
59      endif
60    endif
61  endif
62endif
63	@:
64
65# Actually do the build, if requested.
66PHONY += gcc-plugins
67gcc-plugins: scripts_basic gcc-plugins-check
68ifdef CONFIG_GCC_PLUGINS
69	$(Q)$(MAKE) $(build)=scripts/gcc-plugins
70endif
71	@:
72